//+------------------------------------------------------------------+
//|                                            TrendFletAnalysis.mq4 |
//|                                      Copyright  2008, komposter |
//|                                      mailto:komposterius@mail.ru |
//+------------------------------------------------------------------+
//   Candid'         
#property copyright "Copyright  2008, komposter"
#property link      "mailto:komposterius@mail.ru"
#property show_inputs

extern int		Sample   				= 100;
extern int		ind_Points				= 100;
extern double	ind_Percent				= 0.0;
extern bool		ind_Show_C0				= false;
extern color	colorFlet				= White;
extern color	colorTrendUP			= Lime;
extern color	colorTrendDN			= Red;

int start()
{
   Comment("! .");
	string name;
	for ( int o = ObjectsTotal()-1; o >= 0; o -- )
	{
		name = ObjectName(o);
		if ( StringFind( name, "TFA_" ) == 0 ) ObjectDelete( name );
	}

	double z, h, l, pre_z, pre_h, pre_l;
	int pre_i = 0, trends_count = 0, flets_count = 0;
	int width, trend_summ_width = 0, flet_summ_width = 0, trend_min_width = 99999, trend_max_width = 0, flet_min_width = 99999, flet_max_width = 0;
	int height, trend_summ_height = 0, flet_summ_height = 0, trend_min_height = 99999, trend_max_height = 0, flet_min_height = 99999, flet_max_height = 0;

	int iPercent = 100*ind_Percent;
	string FileName = "TFA_"+Symbol()+"_"+ind_Points+"_"+iPercent+"_"+Sample+".txt";
	int hndl = FileOpen(FileName,FILE_CSV|FILE_WRITE,';');
   int zz_count = 0;
	for ( int i = Bars - 1; i >= 0; i -- )
	{
		z = iCustom( NULL, 0, "ZZm-fx-txt", ind_Points, ind_Percent, true, false, DeepSkyBlue, Yellow, ind_Show_C0, 0, i );
		if ( z < Point || z == EMPTY_VALUE ) continue;

		h = iCustom( NULL, 0, "ZZm-fx-txt", ind_Points, ind_Percent, true, false, DeepSkyBlue, Yellow, ind_Show_C0, 1, i );
		l = iCustom( NULL, 0, "ZZm-fx-txt", ind_Points, ind_Percent, true, false, DeepSkyBlue, Yellow, ind_Show_C0, 2, i );

		if ( pre_i > 0 )
		{
			ObjectCreate( "TFA_"+i, OBJ_TREND, 0, Time[pre_i], 0.0, Time[i], 0.0 );
			ObjectSet	( "TFA_"+i, OBJPROP_RAY, false );
			ObjectSet	( "TFA_"+i, OBJPROP_WIDTH, 2 );

			width  = pre_i-i;
			zz_count++;

			if ( z > pre_z )
			{
				height = MathAbs( l - pre_h ) / Point;
				ObjectSet( "TFA_"+i, OBJPROP_PRICE1, pre_h );
				ObjectSet( "TFA_"+i, OBJPROP_PRICE2, l );
				if ( l > pre_h )
				{
					ObjectSet( "TFA_"+i, OBJPROP_COLOR, colorTrendUP );
					trends_count ++;
					trend_summ_width += width;
					trend_min_width = MathMin( trend_min_width, width );
					trend_max_width = MathMax( trend_max_width, width );
					trend_summ_height += height;
					trend_min_height = MathMin( trend_min_height, height );
					trend_max_height = MathMax( trend_max_height, height );
				}
				else
				{
					ObjectSet( "TFA_"+i, OBJPROP_COLOR, colorFlet );
					flets_count ++;
					flet_summ_width += width;
					flet_min_width = MathMin( flet_min_width, width );
					flet_max_width = MathMax( flet_max_width, width );
					flet_summ_height += height;
					flet_min_height = MathMin( flet_min_height, height );
					flet_max_height = MathMax( flet_max_height, height );
				}
			}
			else
			{
				height = MathAbs( h - pre_l ) / Point;
				ObjectSet( "TFA_"+i, OBJPROP_PRICE1, pre_l );
				ObjectSet( "TFA_"+i, OBJPROP_PRICE2, h );
				if ( h < pre_l )
				{
					ObjectSet	( "TFA_"+i, OBJPROP_COLOR, colorTrendDN );
					trends_count ++;
					trend_summ_width += width;
					trend_min_width = MathMin( trend_min_width, width );
					trend_max_width = MathMax( trend_max_width, width );
					trend_summ_height += height;
					trend_min_height = MathMin( trend_min_height, height );
					trend_max_height = MathMax( trend_max_height, height );
				}
				else
				{
					ObjectSet( "TFA_"+i, OBJPROP_COLOR, colorFlet );
					flets_count ++;
					flet_summ_width += width;
					flet_min_width = MathMin( flet_min_width, width );
					flet_max_width = MathMax( flet_max_width, width );
					flet_summ_height += height;
					flet_min_height = MathMin( flet_min_height, height );
					flet_max_height = MathMax( flet_max_height, height );
				}
			}
		}
      if (zz_count == Sample) {
         zz_count = 0;
			double sample_width = trend_summ_width + flet_summ_width;
         double trend_perc = trend_summ_width/sample_width;
	      double flet_perc  = flet_summ_width /sample_width;
			trend_summ_width = 0;
			flet_summ_width = 0;
			double sample_height = trend_summ_height + flet_summ_height;
	      double trend_perc_height = trend_summ_height/sample_height;
      	double flet_perc_height  = flet_summ_height /sample_height;
	      trend_summ_height = 0;
      	flet_summ_height  = 0;
			FileWrite(hndl,Time[i],trend_perc,flet_perc,trend_perc_height,flet_perc_height);
      }
		pre_i = i;
		pre_z = z;
		pre_h = h;
		pre_l = l;
	}
/*
	trend_perc = trend_summ_width/(Bars/100.0);
	flet_perc  = flet_summ_width /(Bars/100.0);
	trend_perc_height = trend_summ_height/((trend_summ_height+flet_summ_height)/100.0);
	flet_perc_height  = flet_summ_height /((trend_summ_height+flet_summ_height)/100.0);

	string param[14][4];
	param[0][0]		= "";								param[0][1]		= "Trend";																param[0][2]		= "Flet";																param[0][3]		= "All";
	param[1][0]		= "Count";						param[1][1]		= trends_count;														param[1][2]		= flets_count;															param[1][3]		= trends_count+flets_count;
	param[2][0]		= "";								param[2][1]		= "";																		param[2][2]		= "";																		param[2][3]		= "";
	param[3][0]		= "Summ Width (bars)";		param[3][1]		= trend_summ_width;													param[3][2]		= flet_summ_width;													param[3][3]		= trend_summ_width+flet_summ_width;
	param[4][0]		= "Summ Width (%)";			param[4][1]		= DoubleToStr( trend_perc, 1 );									param[4][2]		= DoubleToStr( flet_perc , 1 );									param[4][3]		= 100;
	param[5][0]		= "Min Width (bars)";		param[5][1]		= trend_min_width;													param[5][2]		= flet_min_width;														param[5][3]		= DoubleToStr( MathMin( trend_min_width, flet_min_width ), 0 );
	param[6][0]		= "Max Width (bars)";		param[6][1]		= trend_max_width;													param[6][2]		= flet_max_width;														param[6][3]		= DoubleToStr( MathMin( trend_max_width, flet_max_width ), 0 );
	param[7][0]		= "Ave Width (bars)";		param[7][1]		= DoubleToStr( 1.0*trend_summ_width/trends_count, 1 );	param[7][2]		= DoubleToStr( 1.0*flet_summ_width/flets_count, 1 );		param[7][3]		= DoubleToStr( 1.0*(trend_summ_width+flet_summ_width)/(trends_count+flets_count), 1 );	
	param[8][0]		= "";								param[8][1]		= "";																		param[8][2]		= "";																		param[8][3]		= "";
	param[9][0]		= "Summ Height (points)";	param[9][1]		= trend_summ_height;													param[9][2]		= flet_summ_height;													param[9][3]		= trend_summ_height+flet_summ_height;
	param[10][0]	= "Summ Height (%)";			param[10][1]	= DoubleToStr( trend_perc_height, 1 );							param[10][2]	= DoubleToStr( flet_perc_height, 1 );							param[10][3]	= 100;
	param[11][0]	= "Min Height (points)";	param[11][1]	= trend_min_height;													param[11][2]	= flet_min_height;													param[11][3]	= DoubleToStr( MathMin( trend_min_height, flet_min_height ), 0 );
	param[12][0]	= "Max Height (points)";	param[12][1]	= trend_max_height;													param[12][2]	= flet_max_height;													param[12][3]	= DoubleToStr( MathMin( trend_max_height, flet_max_height ), 0 );
	param[13][0]	= "Ave Height (points)";	param[13][1]	= DoubleToStr( 1.0*trend_summ_height/trends_count, 1 );	param[13][2]	= DoubleToStr( 1.0*flet_summ_height/flets_count, 1 );		param[13][3]	= DoubleToStr( 1.0*(trend_summ_height+flet_summ_height)/(trends_count+flets_count), 1 );	

	for ( int r = 0; r < 14; r ++ )
	{
		_LabelCreate ( "TFA_label_"+r, 10, 10+r*15, param[r][0] );
		for ( int c = 1; c < 4; c ++ )
		{
			_LabelCreate ( "TFA_label_"+r+"_"+c, 150+c*50, 10+r*15, param[r][c] );
		}
	}
/*
	Comment( WindowExpertName(), ":\n",
				"T: ", trends_count, " (", DoubleToStr( trend_perc, 1 ), "%, ", trend_summ_width, " bars)", "\n",
				"F: ", flets_count , " (", DoubleToStr( flet_perc , 1 ), "%, ", flet_summ_width, " bars)", "\n",
				"\n" );*/
	FileClose(hndl);
   Comment("    "+FileName);
	return(0);
}

void _LabelCreate ( string _Name, int _XDistance, int _YDistance, string _Text = "" )
{
	ObjectCreate	( _Name, OBJ_LABEL, 0, 0, 0 );
	ObjectSet		( _Name, OBJPROP_CORNER, 0 );
	ObjectSet		( _Name, OBJPROP_COLOR, White );
	ObjectSet		( _Name, OBJPROP_XDISTANCE, _XDistance );
	ObjectSet		( _Name, OBJPROP_YDISTANCE, _YDistance );
	ObjectSetText	( _Name, _Text, 9 );
}

